#!/bin/bash

# Frações Cíclicas
#
# Arkanon <arkanon@lsd.org.br>
# 2022/11/13 (Sun) 01:29:46 -03
# 2014/11/13 (Thu) 18:43:13 (BRST)
# 2014/11/13 (Thu) 16:33:53 (BRST)
#
# <http://fb.com/arkanon/posts/10202760442363472>
# <http://johndcook.com/blog/2014/11/12/cyclic-fractions>



#     7 : 2 4 3 0 1 5
#  #per : 6
#
#   1/7 = 0.   142 857142 857142 857142
#   2/7 = 0.     2 857142 857142 857142
#   3/7 = 0.    42 857142 857142 857142
#   4/7 = 0. 57142 857142 857142 857142
#   5/7 = 0.  7142 857142 857142 857142
#   6/7 = 0.       857142 857142 857142



#    17 : 15 9 10 3 6 4 8 13 5 0 12 14 11 2 1 7
#  #per : 16
#
#  1/17 = 0.                 0588235294117647 0588235294117647 0588235294117647
#  2/17 = 0.          117647 0588235294117647 0588235294117647 0588235294117647
#  3/17 = 0.           17647 0588235294117647 0588235294117647 0588235294117647
#  4/17 = 0.    235294117647 0588235294117647 0588235294117647 0588235294117647
#  5/17 = 0.       294117647 0588235294117647 0588235294117647 0588235294117647
#  6/17 = 0.     35294117647 0588235294117647 0588235294117647 0588235294117647
#  7/17 = 0.         4117647 0588235294117647 0588235294117647 0588235294117647
#  8/17 = 0.              47 0588235294117647 0588235294117647 0588235294117647
#  9/17 = 0.      5294117647 0588235294117647 0588235294117647 0588235294117647
# 10/17 = 0. 588235294117647 0588235294117647 0588235294117647 0588235294117647
# 11/17 = 0.             647 0588235294117647 0588235294117647 0588235294117647
# 12/17 = 0.               7 0588235294117647 0588235294117647 0588235294117647
# 13/17 = 0.            7647 0588235294117647 0588235294117647 0588235294117647
# 14/17 = 0.   8235294117647 0588235294117647 0588235294117647 0588235294117647
# 15/17 = 0.  88235294117647 0588235294117647 0588235294117647 0588235294117647
# 16/17 = 0.        94117647 0588235294117647 0588235294117647 0588235294117647
#
#  1 12 8 11 13 3 2 7 16 5 9 6 4 14 15 10
#
#  1/17 = 0.                 0588235294117647 0588235294117647 0588235294117647
# 12/17 = 0.               7 0588235294117647 0588235294117647 0588235294117647
#  8/17 = 0.              47 0588235294117647 0588235294117647 0588235294117647
# 11/17 = 0.             647 0588235294117647 0588235294117647 0588235294117647
# 13/17 = 0.            7647 0588235294117647 0588235294117647 0588235294117647
#  3/17 = 0.           17647 0588235294117647 0588235294117647 0588235294117647
#  2/17 = 0.          117647 0588235294117647 0588235294117647 0588235294117647
#  7/17 = 0.         4117647 0588235294117647 0588235294117647 0588235294117647
# 16/17 = 0.        94117647 0588235294117647 0588235294117647 0588235294117647
#  5/17 = 0.       294117647 0588235294117647 0588235294117647 0588235294117647
#  9/17 = 0.      5294117647 0588235294117647 0588235294117647 0588235294117647
#  6/17 = 0.     35294117647 0588235294117647 0588235294117647 0588235294117647
#  4/17 = 0.    235294117647 0588235294117647 0588235294117647 0588235294117647
# 14/17 = 0.   8235294117647 0588235294117647 0588235294117647 0588235294117647
# 15/17 = 0.  88235294117647 0588235294117647 0588235294117647 0588235294117647
# 10/17 = 0. 588235294117647 0588235294117647 0588235294117647 0588235294117647



#    19 : 16 15 3 14 0 2 10 13 8 17 4 1 11 9 5 12 6 7
#  #per : 18
#
#  1/19 = 0.                 0 526315789473684210 526315789473684210 526315789473684210
#  2/19 = 0.                10 526315789473684210 526315789473684210 526315789473684210
#  3/19 = 0.    15789473684210 526315789473684210 526315789473684210 526315789473684210
#  4/19 = 0.               210 526315789473684210 526315789473684210 526315789473684210
#  5/19 = 0. 26315789473684210 526315789473684210 526315789473684210 526315789473684210
#  6/19 = 0.   315789473684210 526315789473684210 526315789473684210 526315789473684210
#  7/19 = 0.           3684210 526315789473684210 526315789473684210 526315789473684210
#  8/19 = 0.              4210 526315789473684210 526315789473684210 526315789473684210
#  9/19 = 0.         473684210 526315789473684210 526315789473684210 526315789473684210
# 10/19 = 0.                   526315789473684210 526315789473684210 526315789473684210
# 11/19 = 0.     5789473684210 526315789473684210 526315789473684210 526315789473684210
# 12/19 = 0.  6315789473684210 526315789473684210 526315789473684210 526315789473684210
# 13/19 = 0.            684210 526315789473684210 526315789473684210 526315789473684210
# 14/19 = 0.          73684210 526315789473684210 526315789473684210 526315789473684210
# 15/19 = 0.      789473684210 526315789473684210 526315789473684210 526315789473684210
# 16/19 = 0.             84210 526315789473684210 526315789473684210 526315789473684210
# 17/19 = 0.       89473684210 526315789473684210 526315789473684210 526315789473684210
# 18/19 = 0.        9473684210 526315789473684210 526315789473684210 526315789473684210



#  1/13 = 0.   076 923076 923076 923076
#  3/13 = 0. 23076 923076 923076 923076
#  4/13 = 0.  3076 923076 923076 923076
#  9/13 = 0.     6 923076 923076 923076
# 10/13 = 0.    76 923076 923076 923076
# 12/13 = 0.       923076 923076 923076
#
#  2/13 = 0.     1 538461 538461 538461
#  5/13 = 0. 38461 538461 538461 538461
#  6/13 = 0.   461 538461 538461 538461
#  7/13 = 0.       538461 538461 538461
#  8/13 = 0.    61 538461 538461 538461
# 11/13 = 0.  8461 538461 538461 538461



magics="
 7 :  2  4  3  0  1  5
17 : 15  9 10  3  6  4  8 13  5  0 12 14 11  2  1  7
19 : 16 15  3 14  0  2 10 13  8 17  4  1 11  9  5 12  6  7
"

if [ $# = 0 ]
then
  validn=$(echo $(echo "$magics" | cut -d: -f1))
  echo "Usage: $(basename $0) <n:($validn)> <scale>"
  exit
fi

  n=$1
sci=${2:-$((3*(n-1)))}

sep=:
mag=($(echo "$magics" | grep "^ *$n *$sep" | cut -d$sep -f2))

printf "\n%${#n}s $n : ${mag[*]}\n\n"

for i in $(seq $((n-1)))
do
  [ "$mag" ] && sce=${mag[$((i-1))]} || sce=0
  printf "%${#n}i/%i = %${sce}s0" $i $n
  BC_LINE_LENGTH=0 bc <<< "scale=$sci-2+$n-$sce;$i/$n"
done
echo



# EOF
